Bug 719152 - Review Request: gappalib-coq - Coq support library for gappa
Summary: Review Request: gappalib-coq - Coq support library for gappa
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Markus Mayer
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 719150
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-07-05 22:07 UTC by Jerry James
Modified: 2011-11-19 06:07 UTC (History)
3 users (show)

Fixed In Version: gappalib-coq-0.16.0-3.fc16
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-11-19 06:07:17 UTC
Type: ---
LotharLutz: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Jerry James 2011-07-05 22:07:33 UTC
Spec URL: http://jjames.fedorapeople.org/gappalib-coq/gappalib-coq.spec
SRPM URL: http://jjames.fedorapeople.org/gappalib-coq/gappalib-coq-0.16.0-1.fc15.src.rpm
Description: This support library provides vernacular files so that the certificates Gappa generates can be imported by the Coq proof assistant.  It also provides a "gappa" tactic that calls Gappa on the current Coq goal.

Gappa (Génération Automatique de Preuves de Propriétés Arithmétiques -- automatic proof generation of arithmetic properties) is a tool intended to help verifying and formally proving properties on numerical programs dealing with floating-point or fixed-point arithmetic.

This package is needed to enable optional functionality in the gappa package.

Comment 1 Jerry James 2011-10-26 21:55:03 UTC
I have split out a -devel subpackage as was done with flocq.  New URLs:

http://jjames.fedorapeople.org/gappalib-coq/gappalib-coq.spec
http://jjames.fedorapeople.org/gappalib-coq/gappalib-coq-0.16.0-2.fc15.src.rpm

Comment 2 Markus Mayer 2011-10-29 09:03:28 UTC
Hi Jerry,

I am taking this.

Maybe you want to review a package of mine:
https://bugzilla.redhat.com/show_bug.cgi?id=737263

Regards,
Markus

Comment 3 Markus Mayer 2011-10-29 10:21:35 UTC
Unfortunatelly am not able to build you package:

ERROR:
+ ./configure --prefix=/usr --datadir=/usr/share
checking for a BSD-compatible install... /usr/bin/install -c
checking whether build environment is sane... yes
checking for a thread-safe mkdir -p... /bin/mkdir -p
checking for gawk... gawk
checking whether make sets $(MAKE)... yes
checking for coqc >= 8.3... /usr/bin/coqc
checking for coqdep... /usr/bin/coqdep
checking for ocamlc... no
checking for camlp5... /usr/bin/camlp5
checking for ocamlopt >= 3.11... which: no ocamlopt in (/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin:/root/bin)

checking for Flocq... no
configure: error:  *** Unable to find the Flocq library (http://flocq.gforge.inria.fr/)
error: Bad exit status from /var/tmp/rpm-tmp.w4N0kf (%build)

flocq is already installed!

Please fix this, so I can go on with reviewing your package.

Things I have already discovered:

- The naming guidelines says "If a new package is considered an "addon" package that enhances or adds a new functionality to an existing Fedora package without being useful on its own, its name should reflect this fact.

The new package ("child") should prepend the "parent" package in its name, in the format: %{parent}-%{child}."

Therefor the package name should be "gaapa-coq". On the other hand it says "When naming a package, the name should match the upstream tarball or project name from which this software came." So gaapalib-coq would be correct to. I am fine with both of them. Just take a look at the two names and decide for yourself.

- Please use %{buildroot} instead of $RPM_BUILD_ROOT

- You could create a marco for the coq version. So you dont have to maintain it on two places (Line 21 & 26 ).

Comment 4 Jerry James 2011-10-29 23:04:13 UTC
(In reply to comment #3)
> Unfortunatelly am not able to build you package:

Argh, I thought the ocaml-camlp5-devel BR would drag in ocaml, but it doesn't.  I changed the spec file to explicitly BR ocaml.

> - The naming guidelines says "If a new package is considered an "addon" package
> that enhances or adds a new functionality to an existing Fedora package without
> being useful on its own, its name should reflect this fact.
> 
> The new package ("child") should prepend the "parent" package in its name, in
> the format: %{parent}-%{child}."
> 
> Therefor the package name should be "gaapa-coq". On the other hand it says
> "When naming a package, the name should match the upstream tarball or project
> name from which this software came." So gaapalib-coq would be correct to. I am
> fine with both of them. Just take a look at the two names and decide for
> yourself.

Heh.  Actually, the first version of this package was named gappa-coq.  After awhile, though, I thought I should go with the upstream naming, and changed it to its current name.  I think I would like to go with the current name.

> - Please use %{buildroot} instead of $RPM_BUILD_ROOT

Why?

> - You could create a marco for the coq version. So you dont have to maintain it
> on two places (Line 21 & 26 ).

Good idea.  I have made that change.  New URLs:

http://jjames.fedorapeople.org/gappalib-coq/gappalib-coq.spec
http://jjames.fedorapeople.org/gappalib-coq/gappalib-coq-0.16.0-3.fc17.src.rpm

Comment 5 Markus Mayer 2011-10-31 11:28:43 UTC
Must items:
OK: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
OK: The package must be named according to the Package Naming Guidelines.
OK: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
OK: The package must meet the Packaging Guidelines.
OK: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
OK: The License field in the package spec file must match the actual license.
OK: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
OK: The spec file must be written in American English.
OK: The spec file for the package MUST be legible.
OK: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
OK: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
N/A: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
OK: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
N/A: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
N/A: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. 
OK: Packages must NOT bundle copies of system libraries.
N/A: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
OK: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
OK: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
OK: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
NOK[1]Each package must consistently use macros.
OK: The package must contain code, or permissable content.
N/A: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
OK: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
NOK[2]: Header files must be in a -devel package.
N/A: Static libraries must be in a -static package.
N/A: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
OK: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
OK: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
N/A: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
OK: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
OK:All filenames in rpm packages must be valid UTF-8.

Should items:
N/A: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
N/A: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
OK: The reviewer should test that the package builds in mock.
Not tested: The package should compile and build into binary rpms on all supported architectures.
Not tested: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
N/A: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
N/A: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
N/A: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
N/A: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
N/A: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.

NOK[1]: Please use %{buildroot} instead of $RPM_BUILD_ROOT. That is just for usabilty as it is easier to read if there is just one macro style used. See Package guidelines: "Mixing the two styles, while valid, is bad from a QA and usability point of view, and should not be done in Fedora packages."

NOK[2]: Can *.v files be considered as header files? As far as I understand they more than source files. I think the devel subpackage should be considered as "Install this package, if you want to develope a application/library that uses the base package". E.g. the devel package for an library written in C only contains the header files, because they are required to link the library. If someone wants the source files not for developing, but for just looking at it, he is required to install the source package.

As Thomas Spura already mentioned on his review for flocq you should consider to doing a packaging draft and send it to fpc to clarify this.

rpmlint output:
gappalib-coq.src: W: spelling-error %description -l en_US Gappa -> Kappa, Zappa, Gap pa
gappalib-coq.src: W: spelling-error %description -l en_US de -> DE, ed, d
gappalib-coq.src:60: W: configure-without-libdir-spec
gappalib-coq.x86_64: W: spelling-error %description -l en_US de -> DE, ed, d
gappalib-coq-devel.x86_64: W: only-non-binary-in-usr-lib
gappalib-coq-devel.x86_64: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 6 warnings.

Well, all spelling errors can be ignored.
configure-without-libdir-spec: As your package does not need any file from libdir. I also think that this can be ignored.
only-non-binary-in-usr-lib: Please see NOK[2]

Comment 6 Jerry James 2011-10-31 17:55:50 UTC
Thanks for the review!

(In reply to comment #5)
> NOK[1]: Please use %{buildroot} instead of $RPM_BUILD_ROOT. That is just for
> usabilty as it is easier to read if there is just one macro style used. See
> Package guidelines: "Mixing the two styles, while valid, is bad from a QA and
> usability point of view, and should not be done in Fedora packages."

You're talking about this:

https://fedoraproject.org/wiki/Packaging:Guidelines#Using_.25.7Bbuildroot.7D_and_.25.7Boptflags.7D_vs_.24RPM_BUILD_ROOT_and_.24RPM_OPT_FLAGS

But I am not mixing the two styles discussed in that section.  There is no instance of either %{buildroot} or %{optflags} in this spec file, therefore this is a straight $RPM_BUILD_ROOT + $RPM_OPT_FLAGS style.  I don't understand what you are objecting to.

> NOK[2]: Can *.v files be considered as header files? As far as I understand
> they more than source files. I think the devel subpackage should be considered
> as "Install this package, if you want to develope a application/library that
> uses the base package". E.g. the devel package for an library written in C only
> contains the header files, because they are required to link the library. If
> someone wants the source files not for developing, but for just looking at it,
> he is required to install the source package.

The .v files are for human consumption only.  They are not necessary for any computerized task.  It is possible to compile applications that use gappalib-coq without needing the .v files.  In that regard, they're kind of like the various emacs-foo-el packages; nothing in Fedora requires the contents of those packages, but they are useful for humans to look at.

If -devel isn't a good name for this subpackage, then how about -source?

> As Thomas Spura already mentioned on his review for flocq you should consider
> to doing a packaging draft and send it to fpc to clarify this.

Yes, I will do this.  It will probably take me a few days to complete.  Thanks.

Comment 7 Markus Mayer 2011-10-31 18:16:11 UTC
(In reply to comment #6)
> Thanks for the review!
> 
> (In reply to comment #5)
> > NOK[1]: Please use %{buildroot} instead of $RPM_BUILD_ROOT. That is just for
> > usabilty as it is easier to read if there is just one macro style used. See
> > Package guidelines: "Mixing the two styles, while valid, is bad from a QA and
> > usability point of view, and should not be done in Fedora packages."
> 
> You're talking about this:
> 
> https://fedoraproject.org/wiki/Packaging:Guidelines#Using_.25.7Bbuildroot.7D_and_.25.7Boptflags.7D_vs_.24RPM_BUILD_ROOT_and_.24RPM_OPT_FLAGS
> 
> But I am not mixing the two styles discussed in that section.  There is no
> instance of either %{buildroot} or %{optflags} in this spec file, therefore
> this is a straight $RPM_BUILD_ROOT + $RPM_OPT_FLAGS style.  I don't understand
> what you are objecting to.
> 

Yes, you are right. I have missinterpreted this section a bit.

> > NOK[2]: Can *.v files be considered as header files? As far as I understand
> > they more than source files. I think the devel subpackage should be considered
> > as "Install this package, if you want to develope a application/library that
> > uses the base package". E.g. the devel package for an library written in C only
> > contains the header files, because they are required to link the library. If
> > someone wants the source files not for developing, but for just looking at it,
> > he is required to install the source package.
> 
> The .v files are for human consumption only.  They are not necessary for any
> computerized task.  It is possible to compile applications that use
> gappalib-coq without needing the .v files.  In that regard, they're kind of
> like the various emacs-foo-el packages; nothing in Fedora requires the contents
> of those packages, but they are useful for humans to look at.
> 
> If -devel isn't a good name for this subpackage, then how about -source?
> 
> > As Thomas Spura already mentioned on his review for flocq you should consider
> > to doing a packaging draft and send it to fpc to clarify this.
> 
> Yes, I will do this.  It will probably take me a few days to complete.  Thanks.

emacs-foo-el packages exists for two reasons (source: http://fedoraproject.org/wiki/Packaging:Emacs):
- It is often the case that byte compiling the elisp source for one add-on will require the presence of the elisp source for another add-on package at build time for example. 

- When debugging a problem with an (X)Emacs package, the Elisp debugger can look up the relevant code or symbol definition in the source lisp file if present. 

If a user just wants to source to look at it, it is already possible using 'yumdownloader --source packagename'.

Maybe this can help you finding your way.


Regards,

Markus

Comment 8 Jerry James 2011-10-31 22:29:22 UTC
(In reply to comment #7)
> emacs-foo-el packages exists for two reasons

Good point.  If I drop the -devel subpackage altogether, would you find this package acceptable?

Comment 9 Markus Mayer 2011-11-01 09:39:43 UTC
Well, If you drop the -devel package I am totaly fine with it.

But if you think that putting the sources in an subpackage brings benefit to the user I am also fine with that. If you decide this way I have only two requirenments:
- Dont call it -devel, because users expect other functions from thouth kind of packages. (maybe -v is a good name?)
- Add a description like for -el packages: This package contains the elisp source files for APEL under GNU Emacs. You do not need to install this package to run APEL. Install the emacs-apel package to use APEL with GNU Emacs.


If you have any other questions, feel free to contact me.


This package is APPROVED

Comment 10 Jerry James 2011-11-02 22:09:44 UTC
I think there is value, so I will call the subpackage -source.  I'll have to go back and change the flocq package to match.  And I'll change the description as noted.  Thanks so much for the review!

New Package SCM Request
=======================
Package Name: gappalib-coq
Short Description: Coq support library for gappa
Owners: jjames
Branches: f16
InitialCC:

Comment 11 Gwyn Ciesla 2011-11-03 01:29:06 UTC
Git done (by process-git-requests).

Comment 12 Fedora Update System 2011-11-10 15:59:12 UTC
gappalib-coq-0.16.0-3.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/gappalib-coq-0.16.0-3.fc16

Comment 13 Fedora Update System 2011-11-11 01:26:28 UTC
gappalib-coq-0.16.0-3.fc16 has been pushed to the Fedora 16 testing repository.

Comment 14 Fedora Update System 2011-11-19 06:07:17 UTC
gappalib-coq-0.16.0-3.fc16 has been pushed to the Fedora 16 stable repository.


Note You need to log in before you can comment on or make changes to this bug.